/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2016-2017 Antonio Cau, David Smallwood 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

load "../library/conversion".
load "../library/exprog".

/* scala Simple2 0 */

set print_states = true.    

define get_var(X,Y) = 
{
    exists T : { 
       get2(T) and 
       if avar(T)=X then {Y=strint(aval(T))}
       else empty
   }
}.    

/* run */ define test() = {
   exists I #3: 
   {  
       sometimes(I=5) and
       {
          prog_send(2);
          {get_var("I", I) and skip  and output(I)};
          {get_var("I", I) and skip  and output(I)};
          {get_var("I", I) and skip  and output(I)};
          {get_var("I", I) and empty and output(I)}
          
       }
       and len(3) and exists k: { I=k and fin(I=k+3)}
     /*  and fin(nprev(I,1)=5 and output(nprev(I,1))) */
     /*  and fin(nprev(I,2)=4 and output(nprev(I,2))) */
       and forall i<2: { fin(nprev(I,i+1) = nprev(I,i+2) + 1) }
   }
}.

